
var render_to_texture_obj = function() {

// ---

var object_handle = {}; // holds all the various flavors of graphic object types

var animals_render_to_texture  = "animals_render_to_texture";

object_handle[animals_render_to_texture] = {};

var all_object_labels = [];

all_object_labels.push(animals_render_to_texture);

// ------------


var SIZE_DIM_3D = 3;
var NUM_ITEMS = 24;


// var cubeVertexPositionBuffer;
// var cubeVertexTextureCoordBuffer;
// var cubeVertexIndexBuffer;

// var neheTexture;

function init_buffers(gl) {

    // cubeVertexPositionBuffer = gl.createBuffer();
    object_handle[animals_render_to_texture].vertex_position_buffer = gl.createBuffer();

    // gl.bindBuffer(gl.ARRAY_BUFFER, cubeVertexPositionBuffer);
    gl.bindBuffer(gl.ARRAY_BUFFER, object_handle[animals_render_to_texture].vertex_position_buffer);

    var vertices = [

        // Front face
        -1.0, -1.0,  1.0,
         1.0, -1.0,  1.0,
         1.0,  1.0,  1.0,
        -1.0,  1.0,  1.0,

        // Back face
        -1.0, -1.0, -1.0,
        -1.0,  1.0, -1.0,
         1.0,  1.0, -1.0,
         1.0, -1.0, -1.0,

        // Top face
        -1.0,  1.0, -1.0,
        -1.0,  1.0,  1.0,
         1.0,  1.0,  1.0,
         1.0,  1.0, -1.0,

        // Bottom face
        -1.0, -1.0, -1.0,
         1.0, -1.0, -1.0,
         1.0, -1.0,  1.0,
        -1.0, -1.0,  1.0,

        // Right face
         1.0, -1.0, -1.0,
         1.0,  1.0, -1.0,
         1.0,  1.0,  1.0,
         1.0, -1.0,  1.0,

        // Left face
        -1.0, -1.0, -1.0,
        -1.0, -1.0,  1.0,
        -1.0,  1.0,  1.0,
        -1.0,  1.0, -1.0,
    ];

    // object_handle[animals_render_to_texture].vertices = new Float32Array(vertices);

    // gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(vertices), gl.STATIC_DRAW);
    // gl.bufferData(gl.ARRAY_BUFFER, object_handle[animals_render_to_texture].vertices, gl.STATIC_DRAW);
    gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(vertices), gl.STATIC_DRAW);

    object_handle[animals_render_to_texture].vertex_position_buffer.itemSize = SIZE_DIM_3D;
    object_handle[animals_render_to_texture].vertex_position_buffer.numItems = NUM_ITEMS;


    // cubeVertexTextureCoordBuffer = gl.createBuffer();
    object_handle[animals_render_to_texture].vertex_texture_coord_buffer = gl.createBuffer();

    // gl.bindBuffer(gl.ARRAY_BUFFER, cubeVertexTextureCoordBuffer);
    gl.bindBuffer(gl.ARRAY_BUFFER, object_handle[animals_render_to_texture].vertex_texture_coord_buffer);

    var textureCoords = [

      // Front face
      0.0, 0.0,
      1.0, 0.0,
      1.0, 1.0,
      0.0, 1.0,

      // Back face
      1.0, 0.0,
      1.0, 1.0,
      0.0, 1.0,
      0.0, 0.0,

      // Top face
      0.0, 1.0,
      0.0, 0.0,
      1.0, 0.0,
      1.0, 1.0,

      // Bottom face
      1.0, 1.0,
      0.0, 1.0,
      0.0, 0.0,
      1.0, 0.0,

      // Right face
      1.0, 0.0,
      1.0, 1.0,
      0.0, 1.0,
      0.0, 0.0,

      // Left face
      0.0, 0.0,
      1.0, 0.0,
      1.0, 1.0,
      0.0, 1.0,
    ];

    // object_handle[animals_render_to_texture].texture_coords = new Float32Array(textureCoords);

    // gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(textureCoords), gl.STATIC_DRAW);
    // gl.bufferData(gl.ARRAY_BUFFER, object_handle[animals_render_to_texture].texture_coords, gl.STATIC_DRAW);
    gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(textureCoords), gl.STATIC_DRAW);


    // cubeVertexTextureCoordBuffer.itemSize = 2;
    // cubeVertexTextureCoordBuffer.numItems = 24;

    // object_handle[animals_render_to_texture].texture_coords.itemSize = SIZE_DIM_3D;
    // object_handle[animals_render_to_texture].texture_coords.numItems = NUM_ITEMS;


    object_handle[animals_render_to_texture].vertex_texture_coord_buffer.itemSize = SIZE_DIM_3D;
    object_handle[animals_render_to_texture].vertex_texture_coord_buffer.numItems = NUM_ITEMS;



    // cubeVertexIndexBuffer = gl.createBuffer();
    object_handle[animals_render_to_texture].vertex_index_buffer = gl.createBuffer();

    gl.bindBuffer(gl.ELEMENT_ARRAY_BUFFER, object_handle[animals_render_to_texture].vertex_index_buffer);

    var cubeVertexIndices = [
        0, 1, 2,      0, 2, 3,    // Front face
        4, 5, 6,      4, 6, 7,    // Back face
        8, 9, 10,     8, 10, 11,  // Top face
        12, 13, 14,   12, 14, 15, // Bottom face
        16, 17, 18,   16, 18, 19, // Right face
        20, 21, 22,   20, 22, 23  // Left face
    ];

    // object_handle[animals_render_to_texture].indices = new Uint16Array(cubeVertexIndices);

    // gl.bufferData(gl.ELEMENT_ARRAY_BUFFER, object_handle[animals_render_to_texture].indices, gl.STATIC_DRAW);
    gl.bufferData(gl.ELEMENT_ARRAY_BUFFER, new Uint16Array(cubeVertexIndices), gl.STATIC_DRAW);

    // cubeVertexIndexBuffer.itemSize = 1;
    // cubeVertexIndexBuffer.numItems = 36;

    object_handle[animals_render_to_texture].vertex_index_buffer.itemSize = 1;
    object_handle[animals_render_to_texture].vertex_index_buffer.numItems = 36;
}

function handleLoadedTexture(gl, texture) {

    gl.bindTexture(gl.TEXTURE_2D, texture);
    gl.pixelStorei(gl.UNPACK_FLIP_Y_WEBGL, true);
    gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, gl.RGBA, gl.UNSIGNED_BYTE, texture.image);
    gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.NEAREST);
    gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.NEAREST);
    gl.bindTexture(gl.TEXTURE_2D, null);
}

function init_texture(gl) {

    object_handle[animals_render_to_texture].texture = gl.createTexture();
    object_handle[animals_render_to_texture].texture.image = new Image();
    object_handle[animals_render_to_texture].texture.image.onload = function () {

        handleLoadedTexture(gl, object_handle[animals_render_to_texture].texture);
    };

    object_handle[animals_render_to_texture].texture.image.src = "nehe.gif";
}

function init(gl) {

    init_buffers(gl);
    init_texture(gl);

    // ----------------------

}       //      init

var get_object_handle = function() {

    return object_handle;
};

var get_all_object_labels = function() {

    return all_object_labels;
};

return {    // to make visible to calling reference frame list function here

    init                  : init,
    get_object_handle     : get_object_handle,
    get_all_object_labels : get_all_object_labels
};

}();    //  render_to_texture_obj = function() 


