function previewHide( me )
{
    me.mBase.style.visibility = "hidden";
    me.mCanvas.style.visibility = "hidden";
    if( gUseScreenshots ) me.mCanvas2D.style.visibility = "hidden";
    me.mNoWebGL.style.visibility = "hidden";
    me.mError.style.visibility = "hidden";
}

function previewShowRender( me )
{
    me.mBase.style.visibility = "visible";
    me.mCanvas.style.visibility = "visible";
    if( gUseScreenshots ) me.mCanvas2D.style.visibility = "hidden";
    me.mNoWebGL.style.visibility = "hidden";
    me.mError.style.visibility = "hidden";
}

function previewShowScreenshot( me )
{
    me.mBase.style.visibility = "visible";
    me.mCanvas.style.visibility = "hidden";
    if( gUseScreenshots ) me.mCanvas2D.style.visibility = "visible";
    me.mNoWebGL.style.visibility = "hidden";
    me.mError.style.visibility = "hidden";
}

function previewShowLoading( me )
{
    me.mBase.style.visibility = "visible";
    me.mCanvas.style.visibility = "hidden";
    if( gUseScreenshots ) me.mCanvas2D.style.visibility = "hidden";
    me.mNoWebGL.style.visibility = "hidden";
    me.mError.style.visibility = "hidden";
}

function previewShowNoWebGL( me, addEvents )
{
    me.mBase.style.visibility = "visible";
    me.mCanvas.style.visibility = "hidden";
    if( gUseScreenshots ) me.mCanvas2D.style.visibility = "hidden";
    me.mNoWebGL.style.visibility = "visible";
    me.mError.style.visibility = "hidden";
}

function previewShowError( me )
{
    me.mBase.style.visibility = "visible";
    me.mCanvas.style.visibility = "hidden";
    if( gUseScreenshots ) me.mCanvas2D.style.visibility = "hidden";
    me.mNoWebGL.style.visibility = "hidden";
    me.mError.style.visibility = "visible";
}

function previewCheckScreenshotAvailable( url )
{
    var http = createHttpReques();
    http.open('HEAD', url, false);
    http.send();
    return http;
}

function previewRedraw( me )
{
    if( gUseScreenshots && me.mScreenshot != null )
    {
        var xres = me.mPreview.mBase.offsetWidth;
        var yres = me.mPreview.mBase.offsetHeight;

        var context = me.m2DContext;
        context.drawImage(me.mScreenshot, 0, 0, xres, yres);

        context.shadowBlur=20;
        context.shadowColor="black";
        context.fillStyle="#FF0000";
        context.fillRect(xres - context.measureText("preview").width - context.measureText("p").width, 0, xres, yres/5);

        context.shadowBlur=0;
        context.fillStyle="#FFFFFF";
        context.font="8px verdana";
        context.fillText("preview", xres - context.measureText("preview").width - context.measureText("p").width/2, yres/6);
    }
    else
    {
        me.gEffect.Paint( me.mTime, 0, 0, 0, 0, false );
    }
}

function previewLoadScreenshot( me )
{
    var url = "/media/shaders/" + me.mShaderID + ".jpg";
    var prev = previewCheckScreenshotAvailable(url);
    if( prev.status != 404 )
    {	    
        // load image from data url
        me.mScreenshot = new Image();
        me.mScreenshot.onload = function() 
        {
            previewRedraw(me);
        };
        me.mScreenshot.src = url;
        
        return true;
    }
    return false;
}

function resizePreview( me, w, h )
{
      var bar = me.mCanvas;
      bar.width  = w;
      bar.height = h;
      bar.style.left = "0px";
      bar.style.top  = "0px";
      bar.style.width  = w + "px";
      bar.style.height = h + "px";
      bar.style.position = "absolute";

      if( gUseScreenshots )
      {
          var bar2D = me.mCanvas2D;
          bar2D.width  = w;
          bar2D.height = h;
          bar2D.style.left = "0px";
          bar2D.style.top  = "0px";
          bar2D.style.width  = w + "px";
          bar2D.style.height = h + "px";
          bar2D.style.position = "absolute";
      }

      var cont = me.mCont;
      cont.style.width =  w + "px";
      cont.style.left = "0px";
      cont.style.top  = h + 2 + "px";
      cont.style.position = "absolute";
}

function createPreview( base, id, x, y, w, h )
{
      w = base.offsetWidth;
      h = base.offsetHeight;
      base.mId = id;

      var bar = document.createElement("canvas");
      bar.width  = w;
      bar.height = h;
      bar.style.width  = w + "px";
      bar.style.height = h + "px";
      bar.style.left = "0px";
      bar.style.top  = "0px";
      bar.style.padding = "0px";
      bar.style.margin = "0px";
      bar.style.position = "absolute";
      bar.style.cursor = "pointer";
      bar.mId = id;
      bar.style.visibility = "hidden";
      bar.style.borderRadius = "8px";
      base.appendChild( bar );
      bar.style.border = "0px solid #000000";

      var bar2D = null;
      if( gUseScreenshots )
      {
          bar2D = document.createElement("canvas");
          bar2D.width  = w;
          bar2D.height = h;
          bar2D.style.width  = w + "px";
          bar2D.style.height = h + "px";
          bar2D.style.left = "0px";
          bar2D.style.top  = "0px";
          bar2D.style.padding = "0px";
          bar2D.style.margin = "0px";
          bar2D.style.position = "absolute";
          bar2D.style.cursor = "pointer";
          bar2D.mId = id;
          bar2D.style.visibility = "hidden";
          bar2D.style.borderRadius = "8px";
         //bar.style.border = "1px solid #606060";
          base.appendChild( bar2D );
          bar2D.style.border = "0px solid #000000";
      }

      var cont = document.createElement( "div" );
      cont.style.width =  w + "px";
      cont.style.left = "0px";
      cont.style.top  = h + 1 + "px";
      cont.style.position = "absolute";
      base.appendChild( cont );

      var textA = document.createElement( "text" );
      textA.className = "previewText";
      cont.appendChild( textA );

      var textC = document.createElement( "text" );
      textC.className = "previewStats";
      cont.appendChild( textC );

      //----------------
      var div = document.createElement("div");
      div.style.left   = "0px";
      div.style.top    = "0px";
      div.style.width  = "100%";
      div.style.height = "100%";
      div.style.padding= "0px";
      div.style.margin = "0px";
      div.style.position="absolute";
      div.style.backgroundColor = "#202020";
      div.style.borderRadius = "8px";
      div.style.cursor = "pointer";
      div.style.visibilty = "hidden";
      div.mId = bar.mId;
      base.appendChild( div );

      var divText = document.createElement("div");
      divText.style.width  = "86%";
      divText.style.height = "90%";
      divText.style.paddingLeft="7%";
      divText.style.paddingRight="7%";
      divText.style.paddingTop = "10%";
      divText.style.paddingBottom="0px";
      divText.style.color = "#ffffff";
      var fontSize = (w/32) | 0;
      if( fontSize< 6 ) fontSize =  6;
      if( fontSize>16 ) fontSize = 16;
      divText.style.font="italic bold " + fontSize + "px arial,serif";
      divText.innerHTML = 'Shadertoy needs a WebGL-enabled browser. Minimum Requirements:<ul><li>Firefox 17</li><li>Chrome 23</li><li>Internet Explorer 11</li><li>Safari 8</li></ul>';
      divText.mId = bar.mId;
      div.appendChild( divText );

      //----------------

      var divError = document.createElement("div");
      divError.style.left   = "0px";
      divError.style.top    = "0px";
      divError.style.width  = "100%";
      divError.style.height = "100%";
      divError.style.padding= "0px";
      divError.style.margin = "0px";
      divError.style.position="absolute";
      divError.style.backgroundColor = "#000000";
      divError.style.borderRadius = "8px";
      divError.style.cursor = "pointer";
      divError.style.visibilty = "hidden";
      divError.mId = bar.mId;
      base.appendChild( divError );

      var divTextError = document.createElement("div");
      divTextError.style.top = "50%";
      divTextError.style.position = "absolute";
      divTextError.style.width  = "100%";
      divTextError.style.textAlign = "center";
      divTextError.style.padding="0";
      divTextError.style.margin="auto";
      divTextError.style.color = "#ff0000";
      var fontSize = (w/16) | 0;
      if( fontSize< 6 ) fontSize =  6;
      if( fontSize>24 ) fontSize = 24;
      divTextError.style.font="italic bold " + fontSize + "px arial,serif";     
      divTextError.innerHTML = 'Shader Error';
      divTextError.mId = bar.mId;
      divError.appendChild( divTextError );

    return { mBase:base, mCanvas:bar, mTextA:textA, mTextC:textC, mCont:cont, mNoWebGL: div, mError: divError, mCanvas2D:bar2D };

}


